.\" {PTM/PB/0.1/02-04-1999/"pobierz/ustaw informacje o porcie szeregowym"}
.\" Translation 1999,2000 Przemek Borys <pborys@dione.ids.pl>
.\" Buu... Znowu trudny tekst :(
.\" Copyright 1992, 1993 Rickard E. Faith (faith@cs.unc.edu)
.\" May be distributed under the GNU General Public License
.\" Portions of this text are from the README in setserial-2.01.tar.z,
.\" but I can't figure out who wrote that document.  If anyone knows,
.\" please tell me
.\"
.\" [tytso:19940519.2239EDT]  I did... - Ted Ts'o (tytso@mit.edu)
.\" Sat Aug 27 17:08:38 1994 Changes from Kai Petzke
.\" (wpp@marie.physik.tu-berlin.de) were applied by Rik Faith
.\" (faith@cs.unc.edu)
.\" "
.TH SETSERIAL 8 "Stycze 2000" "Setserial 2.17" "Podrcznik programisty linuksowego"
.SH NAZWA
setserial \- pobierz/ustaw informacje o porcie szeregowym
.SH SKADNIA
.B setserial
.B "[ \-abqvVWz ]"
device
.BR "[ " parameter1 " [ " arg " ] ] ..."

.B "setserial -g"
.B "[ \-abGv ]"
device1 ...
.SH OPIS
.B setserial
jest programem przeznaczonym do ustawiania i/lub raportowania danych
konfiguracyjnych zwizanych z portem szeregowym. Dane te zawieraj
port I/O, numer IRQ, to czy klawisz break powinien by interpretowany jako
Secure Attention Key, itd.

Podczas normalnego bootowania, inicjalizowane s jedynie porty COM 1-4;
uywane s przy tym domylne wartoci portw I/O i IRQ. Aby zainicjalizowa
dodatkowe porty szeregowe, lub aby zmieni konfiguracje portw 1-4, musisz
uy programu
.BR setserial .
Zazwyczaj jest on woany ze skryptu
.IR rc.serial ,
ktry z kolei jest normalnie uruchamiany z
.IR /etc/rc.local .

Argument(y)
.I device
okrela, ktre urzdzenie szeregowe ma by skonfigurowane lub odpytane.
Zazwyczaj przyjmuje posta
.BR /dev/cua[0-3] .

Bez parametrw,
.B setserial
drukuje rodzaj portu np. 8250, 16450, 16550, 16550A), sprztowy port I/O,
sprztow lini IRQ, szybko i niektre flagi operacyjne.

Przy podanej opcji
.BR \-g ,
argumenty setserial s interpretowane jako lista urzdze, dla ktrych
naley wydrukowa charakterystyk.

Bez opcji
.BR \-g ,
pierwszy argument jest interpretowany jako urzdzenie do
zmodyfikowania lub do wydrukowania charakterystyki, a dodatkowe argumenty
interpretowane s jako parametry, ktre powinny by zaaplikowane do tego
urzdzenia.

W wikszoci wypadkw wymagane s uprawnienia superuytkownika. Jednak kilka
opcji portw mog ustawia zwykli uytkownicy i opcje te zostan zaznaczone
jako wyjtki w tym podrczniku.

.SH OPCJE
.B Setserial
przyjmuje nastpujce opcje:

.TP
.B \-a
Podczas raportowania konfiguracji urzdzenia szeregowego, drukuj wszelkie
dostpne informacje.
.TP
.B \-b
Podczas raportowania konfiguracji urzdzenia szeregowego, drukuj
zestawienie konfiguracji urzdzenia, ktre moe by wystarczajce do
wypisania podczas procesu bootowania w skrypcie /etc/rc.
.TP
.B \-G
Wydrukuj informacj o konfiguracji portu szeregowego w postaci, ktra moe
zosta zassana do setseriala jako argumenty linii polece.
.TP
.B \-q
Bd cicho.
.B Setserial
wydrukuje wtedy mniej linii na wyjciu.
.TP
.B \-v
Bd gadatliwy.
.B Setserial
wydrukuje wtedy dodatkowy status na wyjciu.
.TP
.B \-V
Wywietl wersj i zakocz.
.TP
.B \-W
Dokonaj dzikiej inicjalizacji przerwa i zakocz. Opcja ta nie jest istotna
w jdrach po wersji 2.1.
.TP
.B \-z
Zeruj flagi szeregowe przed rozpoczciem ich ustawiania. Jest to zwizane z
automatycznym zachowywaniem flag szeregowych z flag \-G.

.SH PARAMETRY
Portowi szeregowemu mona przyzna niej wymienione parametry.

Wszystkie wartoci argumentw s wartociami dziesitnymi, chyba e
poprzedzone s "0x".

.TP
.BR port " port_number"
Opcja
.B port
ustawia port I/O, jak opisano wyej.
.TP
.BR irq " irq_number"
Opcja
.B irq
ustawia sprztowe IRQ, jak opisano wyej.
.TP
.BR uart " uart_type"
Opcja ta jest uywana do ustawienia typu UART-a. Dozwolone typy to
.BR none ,
8250, 16450, 16550, 16550A, 16650, 16650V2, 16654, 16750, 16850, 16950,
i 16954.
Uycie typu UART
.B none
wyczy port.

Niektre modemy wewntrzne s oznaczone jako majce "UART 16550A z buforem 1K"
Jest to kamstwo. Nie maj w rzeczywistoci UART-a kompatybilnego z 16550A;
zamiast niego maj UART kompatybilny z 16450 z 1K buforem odbiorczym dla
zapobiegania spustoszeniom u odbiorcy. Jest to istotne, poniewa nie maj
one transmitujcego FIFO. Dlatego nie s kompatybilne z UART-em 16550A i
proces autokonfiguracji zidentyfikuje je prawidowo jako 16450. Jeli
sprbujesz obej to, uywajc parametru
.BR uart ,
pojawi si porzucone znaki podczas transmisji plikw. UART-y te maj zwykle
inne problemy: parametr
.B skip_test
powinien by rwnie czsto podawany.
.TP
.B autoconfig
Gdy podano ten parametr,
.B setserial
poprosi jdro o prb automatycznego skonfigurowania portu szeregowego. Port
I/O musi by ustawiony prawidowo; jdro sprbuje okreli typ UART, a
dodatkowo jeli podano parametr
.BR auto_irq ,
Linux sprbuje te automatycznie okreli IRQ.
Parametr
.B autoconfig
powinien by podawany po parametrach
.BR port , auto_irq ", i " skip_test .
.TP
.B auto_irq
Sprbuj podczas autokonfiguracji okreli IRQ. Waciwo ta nie zawsze musi
da prawidowy wynik; niektre konfiguracje sprztowe mog ogupi jdro.
Oglnie, bezpieczniej jest nie uywa waciwoci
.BR auto_irq ,
lecz raczej samemu podawa warto IRQ, uywajc parametru
.BR irq .
.TP
.B ^auto_irq
.I Nie
prbuj okreli IRQ podczas autokonfiguracji.
.TP
.B skip_test
Pomi test UART podczas autokonfiguracji. Niektre modemy wewntrzne nie
maj UART-w kompatybilnych z National Semiconductor, lecz zamiast nich
tanie imitacje. Niektre z nich nie wspieraj w peni trybu detekcji
loopback, ktrego uywa jdro do upewnienia si, czy pod podanym adresem
jest rzeczywicie UART. Dlatego dla niektrych modemw bdzie trzeba poda
ten parametr aby mona byo zainicjalizowa UART prawidowo.
.TP
.B ^skip_test
.I Nie
pomijaj testu UART podczas autokonfiguracji.
.TP
.BR baud_base " baud_base"
Opcja ta ustawia podstawow prdko (baud rate), ktra jest czstotliwoci
zegara podzielon przez 16. Normalnie jest to 115200, co jest zarazem najwiksz
prdkoci wspieran przez UART.
.TP
.B
spd_hi
Gdy aplikacja da 38.4kb, uywaj 57.6kb. Parametr ten moe by ustawiany
przez nieuprzywilejowanego uytkownika.
.TP
.B spd_vhi
Gdy aplikacja da 38.4kb, uywaj 115kb. Parametr ten moe by ustawiany
przez nieuprzywilejowanego uytkownika.
.TP
.B spd_shi
Uyj 230kb gdy aplikacja da 38.4kb. Parametr ten moe by podawany przez
uytkownika nieuprzywilejowanego.
.TP
.B spd_warp
Uyj 460kb gdy aplikacja da 38.4kb. Parametr ten moe by podawany przez
uytkownika nieuprzywilejowanego.
.TP
.B spd_cust
Gdy aplikacja da 38.4kb, uyj ustawionego dzielnika do ustawienia
szybkoci. W tym wypadku, prdko jest okrelona przez
.B baud_base
podzielone przez
.BR divisor (dzielnik).
Parametr ten moe by podawany przez nieuprzywilejowanego uytkownika.
.TP
.B spd_normal
Gdy aplikacja da 38.4kb, uywaj 38.4kb. Parametr ten moe by ustawiany
przez nieuprzywilejowanego uytkownika.
.TP
.BR divisor " divisor"
Opcja ta ustawia konfigurowalny dzielnik. Dzielnik bdzie uywany gdy
wybrana zostanie opcja
.BR spd_cust ,
a port szeregowy bdzie ustawiony przez aplikacj na 38.4kb.
Parametr ten moe by podawany przez nieuprzywilejowanego uytkownika.
.TP
.B sak
Ustaw klawisz break na Secure Attention Key.
.TP
.B ^sak
wycz Secure Attention Key.
.TP
.B fourport
Skonfiguruj port jako kart AST Fourport.
.TP
.B ^fourport
Wycz konfiguracj AST Fourport.
.TP
.BR close_delay " delay"
Podaj ilo czasu w setnych sekundy, podczas ktrych DTR powinien zosta w
stanie obnionym na linii szeregowej po tym, jak urzdzenie wydzwaniajce
(callout device) jest zamykane, zanim blokowane urzdzenie wdzwaniajce si
(dialin device) znw podniesie DTR. Domyln wartoci tej opcji jest 50 lub
p sekundy.
.TP
.BR closing_wait " opnienie"
Podaj ilo czasu w setnych sekundy, podczas ktrej jdro powinno czeka na
dane nadawane z portu szeregowego podczas jego zamykania. Jeli podane
zostanie "none", nie bdzie oczekiwania. Jeli podane zostanie "infinite",
jdro bdzie czeka w nieokrelenie dugo na przybycie buforowanych danych.
Domylnym ustawieniem jest 3000 lub 30 sekund opnienia. Ta warto
domylna jest wskazana dla wikszoci urzdze. Jeli wybrane zostanie
dugie opnienie, to port szeregowy moe si zawiesi na dugi czas podczas
zamykania. Jeli wybrany bdzie zbyt krtki czas, to istnieje ryzyko utraty
danych. Jeli urzdzenie jest bardzo wolne, jak w ploterze, to mona wybra
wiksze wartoci.
.TP
.B session_lockout
Blokuj dostp do portu wydzwaniajcego (/dev/cuaXX) na przestrzeni rnych
sesji. To znaczy, e gdy proces otworzy port, to aden inny proces nie moe
go ju otworzy, dopki pierwszy proces go nie zamknie.
.TP
.B ^session_lockout
Nie blokuj portu wydzwaniajcego na przestrzeni sesji.
.TP
.B pgrp_lockout
Blokuj port wydzwaniajcy (/dev/cuaXX) na przestrzeni rnych grup procesw.
To znaczy, e gdy proces otworzy port, to aden inny proces z innej grupy
procesw nie moe go otworzy, dopki ten proces go nie zamknie.
.TP
.B ^pgrp_lockout
Nie blokuj portu wydzwaniajcego na przestrzeni rnych grup procesw.
.TP
.B hup_notify
Poinformuj proces blokowany na otwieraniu linii wdzwaniajcej, gdy
proces skoczy uywa linii wydzwaniajcej (zarwno przez zamknicie jej,
lub przez zawieszenie jej) przez zwrcenie (funkcji?) open EAGAIN.

Zastosowanie tego parametru odnosi si do getty, ktre s blokowane na
liniach wdzwaniajcych portw szeregowych. Umoliwia to getty zresetowanie
modemu (ktry moe mie dziki aplikacji uywajcej urzdzenia wydzwaniajcego
zmienion konfiguracj) przed ponownym blokowaniem.
.TP
.B ^hup_notify
Nie informuj procesu blokowanego na otwieraniu linii wdzwaniajcej, gdy
urzdzenie wydzwaniajce jest odwieszone.
.TP
.B split_termios
Traktuj ustawienia termios uywane przez urzdzenie wydzwaniajce i
ustawienia urzdzenia wdzwaniajcego osobno.
.TP
.B ^split_termios
Uywaj tej samej struktury termios do przechowywania ustawie urzdzenia
wdzwaniajcego i wydzwaniajcego.
.TP
.B callout_nohup
Jeli dany port szeregowy jest otworzony jako urzdzenie wydzwaniajce, nie
odwieszaj tty gdy porzucony zostanie CD.
.TP
.B ^callout_nohup
Nie pomijaj odwieszania tty gdy port szeregowy jest otworzony jako
urzdzenie wydzwaniajce. Oczywicie musi by wczona flaga HUPCL termios,
jeli odwieszenie ma si pojawi.
.TP
.B low_latency
Minimalizuj opnienia odbioru z urzdzenia szeregowego kosztem 
wikszego zaangaowania CPU. (Normalnie jest 5-10ms opnienie nim znaki
zostan przekazane dyscyplinie linii.) Jest to domylnie wyczone, lecz
niektre aplikacje czasu rzeczywistego mog tego potrzebowa.
.TP
.B ^low_latency
Optymalizuj efektywne przetwarzanie przez CPU znakw szeregowych kosztem
pacenia redniego opnienia 5-10ms nim znaki zostan przetworzone. Jest to
domylne.

.SH ROZWAANIA O KONFIGUROWANIU PORTW SZEREGOWYCH
Wanym jest, by zauway i setserial zwyczajnie mwi jdru Linuksa, gdzie
powinien spodziewa si znale port I/O i linie IRQ okrelonego portu
szeregowego. Nie konfiguruje on sprztu! Aby to uczyni, musisz fizycznie
zaprogramowa kart szeregow, zazwyczaj przez przestawienie zworek, lub
przeczenie przecznikw DIP.

Sekcja ta udostpni pewne wskazwki pomocne w decydowaniu jak skonfigurowa
porty szeregowe.

"Standardowe powizania MS-DOS" zostay pokazane niej:

.nf
.RS
/dev/ttyS0 (COM1), port 0x3f8, irq 4
/dev/ttyS1 (COM2), port 0x2f8, irq 3
/dev/ttyS2 (COM3), port 0x3e8, irq 4
/dev/ttyS3 (COM4), port 0x2e8, irq 3
.RE
.fi

Z powodu ogranicze w projekcie architektury szyn AT/ISA, normalnie linia
IRQ nie moe by dzielona midzy dwoma lub wicej portami szeregowymi. Jeli
sprbujesz tak zrobi, jeden lub obydwa z tych portw stan si niedostpne,
gdy sprbujesz uywa ich naraz. Ograniczenie to mona obej przez specjalne
wieloportowe karty szeregowe, ktre s skonstruowane do dzielenia wielu
portw szeregowych na jednej linii IRQ. Karty wspierane przez Linuksa
zawieraj AST FourPort, Accent Async, Usenet Serial II, Bocaboard BB-1004,
BB-1008, i BB-2016, oraz HUB-6.

Wybr alternatywnej linii IRQ jest trudny, gdy prawie wszystkie z nich s
ju w uytku. Nastpujca tabela zawiera wykaz "standardowych przydziaw
MS-DOS" dla linii IRQ:

.nf
.RS
IRQ 3: COM2
IRQ 4: COM1
IRQ 5: LPT2
IRQ 7: LPT1
.RE
.fi

Wiele osb uwaa, e IRQ 5 jest dobrym wyborem, zakadajc e w komputerze
aktywny jest tylko jeden port rwnolegy. Innym dobrym wyborem jest IRQ 2
(aka IRQ 9); chocia to IRQ jest czasem uywane przez karty sieciowe i
bardzo rzadko przez karty VGA (dla przerwania vertical retrace). Jeli twoja
karta VGA jest tak skonfigurowana, sprbuj to wyczy, tak by mg
wykorzysta to IRQ dla innej karty. Nie jest to niezbdne pod GNU/Linuksem i
wikszoci innych systemw operacyjnych.

Jedynymi innymi dostpnymi liniami IRQ s 3, 4 i 7, a s one prawdopodobnie
uywane przez inne porty szeregowe i rwnolege. (Jeli twoja karta
szeregowa ma 16-bitowy edge connector i wspiera wysze numery IRQ, to
dostpne sa te IRQ 10, 11, 12 i 15.)

W maszynach klasy AT, IRQ 2 jest widziane jako IRQ 9 i Linux interpretuje je
w ten sposb.

Przerwania inne ni 2 (9), 3, 4, 5, 7, 10, 11, 12, i 15,
.I nie
powinny by uywane, gdy s przyznane innym elementom sprztowym i oglnie
nie mog by zmieniane. Oto "standardowe" przyznania:

.nf
.RS
IRQ  0      Kana timera 0
IRQ  1      Klawiatura
IRQ  2      Kaskada kontrolera 2
IRQ  3      Port szeregowy 2
IRQ  4      Port szeregowy 1
IRQ  5      Port rwnolegy 2 (Zarezerwowane w PS/2)
IRQ  6      Stacja dyskw
IRQ  7      Port rwnolegy 1
IRQ  8      Zegar czasu rzeczywistego
IRQ  9      Przekierowane na IRQ2
IRQ 10      Zarezerwowane
IRQ 11      Zarezerwowane
IRQ 12      Zarezerwowane (Pomocnicze urzdzenie w PS/2)
IRQ 13      Koprocesor matematyczny
IRQ 14      Kontroler dysku twardego
IRQ 15      Zarezerwowane
.RE
.fi


.SH KONFIGURACJA WIELOPORTOWA

Niektre wieloportowe ukady szeregowe, dzielce wiele portw na jednym IRQ
uywaj jednego lub wicej portw do okrelania czy s tam aktywne porty,
ktre naley obsuy. Jeli twj ukad wieloportowy obsuguje te porty, to
powiniene z nich skorzysta aby zapobiec potencjalnym zablokowaniom, gdy
zginie przerwanie.

Aby ustawi te porty, musisz przekaza
.B set_multiport
jako parametr i wypisa za nim parametry wieloportowe. Parametry
wieloportowe przybieraj posta podania sprawdzanego
.IR portu ,
.IR maski ,
wskazujcej, ktre bity rejestru s znaczce oraz, ostatecznie parametru
.IR dopasowania ,
(match), okrelajcego, ktre bity znaczce tego rejestru musz pasowa, gdy
nie ma ju niczego do zrobienia.

Mona poda do czterech takich kombinacji. Pierwsze kombinacje powinny by
podawane przez ustawianie parametrw
.BR port1 ,
.BR mask1 
i
.BR match1 .
Nastpne przez ustawianie
.BR port2 ,
.BR mask2 
i
.BR match2 ,
itd. Aby wyczy sprawdzanie wieloportowe, ustaw
.B port1
na zero.

Aby obejrze biece ustawienia wieloportowe, podaj w linii polece parametr
.BR get_multiport .

Oto pewne ustawienia wieloportowe dla popularnych ukadw szeregowych:

.nf
.RS
AST FourPort    port1 0x1BF mask1 0xf match1 0xf

Boca BB-1004/8  port1 0x107 mask1 0xff match1 0

Boca BB-2016    port1 0x107 mask1 0xff match1 0
                port2 0x147 mask2 0xff match2 0
.RE
.fi

.SH Konfiguracja ESP Hayesa
.B Setserial
moe by rwnie uywany do konfigurowania portw na ukadzie ESP Hayesa.
.PP
Mona do tego uywa nastpujcych parametrw:
.TP
.B rx_trigger
Jest to poziom wyzwalania (w bajtach) FIFO odbiorczego. Wiksze wartoci
powoduj mniej przerwa i lepsz wydajno; jednak zbyt due wartoci
powoduj utrat danych. Dostpne wartoci to 1 do 1023.
.TP
.B tx_trigger
Jest to poziom wyzwalania (w bajtach) FIFO nadawczego. Wiksze wartoci mog
powodowa mniej przerwa i lepsz wydajno; jednak zbyt due wartoci
powoduj zdegradowan wydajno nadawania. Dostpne wartoci to 1 do 1023.
.TP
.B flow_off
Jest to poziom (w bajtach) przy ktrym port ESP zrobi "flow off" dla
zdalnego nadajnika (tj. powie mu by przesta nadawa wicej
bajtw). Dostpne wartoci to 1 do 1023. Warto ta powinna by wiksza od
poziomu wyzwalania odbiorczego i poziomu flow on.
.TP
.B flow_on
Jest to poziom (w bajtach) przy ktrym port ESP zrobi "flow on" dla zdalnego
nadajnika (tzn. powie mu by wznowi nadawanie bajtw) po "flow off".
Dostpne wartoci to 1 do 1023. Warto ta powinna by mniejsza ni poziom
"flow off", lecz wiksza ni poziom wyzwalania odbiorczego.
.TP
.B rx_timeout
Jest to ilo czasu, przez ktr port ESP powinien czeka po odebraniu
ostatniego znaku przed sygnalizowaniem przerwania. Prawidowe wartoci to 0
do 255. Zbyt dua warto zwikszy opnienia, a zbyt maa spowoduje
niepotrzebne przerwania.

.SH UWAGA
UWAGA: Skonfigurowanie portu szeregowego tak, by uywa nieprawidowego
portu I/O moe zablokowa twoj maszyn.
.SH PLIKI
.BR /etc/rc.local
.BR /etc/rc.serial
.SH "ZOBACZ TAKE"
.BR tty (4),
.BR ttys (4),
kernel/chr_drv/serial.c
.SH AUTOR
Oryginalna wersja setserial zostaa napisana przez Ricka Sladkeya
(jrs@world.std.com) i zostaa zmodyfikowana przez Michaela K. Johnsona
(johnsonm@stolaf.edu).

Ta wersja zostaa od tej pory napisana ponownie od zera przez Theodore Ts'o
(tytso@mit.edu) 1/1/93. Wszelkie bdy i problemy s wycznie jego
odpowiedzialnoci.
