# $Revision: 1.49 $, $Date: 2010/06/06 10:26:12 $
Summary:	Serial interface configuration program
Summary(de.UTF-8):	Konfigurationsprogramm für die serielle Schnittstelle
Summary(es.UTF-8):	Programa de configuración de interface serial
Summary(fr.UTF-8):	Programme de configuration de l'interface série
Summary(pl.UTF-8):	Program konfigurujący interfejsy szeregowe
Summary(pt_BR.UTF-8):	Programa de configuração de interface serial
Summary(ru.UTF-8):	Программа для конфигурации последовательных интерфейсов
Summary(tr.UTF-8):	Seri arayüz ayarlama programı
Summary(uk.UTF-8):	Програма для конфігурації послідовних інтерфейсів
Summary(zh_CN.UTF-8):	[系统]配置串口的工具
Summary(zh_TW.UTF-8):	[-A系$)B統]-A配置$)B串-A口$)B的-A工$)B具
Name:		setserial
Version:	2.17
Release:	19
License:	GPL
Group:		Applications/System
Source0:	ftp://tsx-11.mit.edu/pub/linux/sources/sbin/%{name}-%{version}.tar.gz
# Source0-md5:	c4867d72c41564318e0107745eb7a0f2
Source1:	%{name}-rc.serial
Source2:	%{name}.8.pl
Patch1:		hayesesp.patch
Patch2:		exit.patch
BuildRequires:	autoconf
BuildRequires:	groff
Requires:	rc-scripts
ExcludeArch:	s390 s390x
BuildRoot:	%{tmpdir}/%{name}-%{version}-root-%(id -u -n)

%description
Setserial is a program which allows you to look at and change various
attributes of a serial device, including its port, its IRQ, and other
serial port options. All parameters for automated setup serial port on
startup You can put in /etc/sysconfig/serial in format:

/dev/<serial_device> <setup parameters>

%description -l de.UTF-8
Setserial ist ein Programm zum Einsehen und Ändern verschiedener
Attribute eines seriellen Geräts, z.B. Port, IRQ und andere Optionen
des seriellen Ports.

%description -l es.UTF-8
setserial es un programa que permite visualizar y alterar varios
atributos de un dispositivo serial, incluyendo puerto, IRQ, y otras
opciones.

%description -l fr.UTF-8
setserial est un programme permettant de consulter et de modifier les
différents attributs d"un périphérique série, dont son port, son IRQ
et autres options du port série.

%description -l pl.UTF-8
Setserial umożliwia odczytanie i zmianę wielu parametrów portu
szeregowego (adres, przerwanie itp.). Wszystkie parametry dotyczące
ustawiania parametrów portów szeregowych w trakcie startu systemu
można wstawiać do pliku /etc/sysconfig/serial w formacie:

/dev/<urządzenie> <parametry>

%description -l pt_BR.UTF-8
O setserial é um programa que permite visualizar e alterar vários
atributos de um dispositivo serial, incluindo porta, IRQ, e outras
opções.

%description -l tr.UTF-8
Setserial, bir seri aygıtın bağlantı noktası, kesme numarası gibi
özelliklerini denetlemenizi ve değiştirmenizi sağlayan bir programdır.


%prep
%setup -q
%patch1 -p1
%patch2 -p1

%build
%{__autoconf}
%configure
%{__make}

%install
rm -rf $RPM_BUILD_ROOT
install -d $RPM_BUILD_ROOT/{bin,%{_mandir}/{man8,pl/man8},etc/{rc.d/init.d,sysconfig}}

install setserial $RPM_BUILD_ROOT/bin
install setserial.8 $RPM_BUILD_ROOT%{_mandir}/man8
install %{SOURCE2} $RPM_BUILD_ROOT%{_mandir}/pl/man8/setserial.8

install serial.conf $RPM_BUILD_ROOT/etc/sysconfig/serial

cat << EOF > $RPM_BUILD_ROOT/etc/sysconfig/serial
# File format:
# /dev/<serial_device>	<setup parameters>

EOF
install %{SOURCE1} $RPM_BUILD_ROOT/etc/rc.d/rc.serial

%clean
rm -rf $RPM_BUILD_ROOT

%files
%defattr(644,root,root,755)
%doc README
%attr(755,root,root) /bin/setserial
%attr(754,root,root) /etc/rc.d/rc.serial
%attr(640,root,root) %config(noreplace) %verify(not md5 mtime size) /etc/sysconfig/*

%{_mandir}/man8/*
%lang(pl) %{_mandir}/pl/man8/*

%define date	%(echo `LC_ALL="C" date +"%a %b %d %Y"`)
%changelog
* %{date} PLD Team <feedback@pld-linux.org>
All persons listed below can be reached at <cvs_login>@pld-linux.org

$Log: setserial.spec,v $
Revision 1.49  2010/06/06 10:26:12  wiget
- added hayesesp.patch (remove hayes support if linux/hayesesp.h is missing
- added exit.patch (add missing include for exit() function)
- release 19

Revision 1.48  2008/07/27 22:20:38  arekm
- release 18

Revision 1.47  2008-05-28 18:07:33  glen
- release 17

Revision 1.46  2008-05-28 18:07:06  glen
- rel 16 for fc2 upgrade

Revision 1.45  2007-02-12 22:09:14  glen
- tabs in preamble

Revision 1.44  2007/02/12 01:06:32  baggins
- converted to UTF-8

Revision 1.43  2005/12/13 15:14:18  glen
- adapterized (sorted %verify attrs)

Revision 1.42  2004/09/25 11:20:54  radek
- cosmetics (spaces -> tabs)

Revision 1.41  2004/09/20 00:07:42  havner
- [mass commit] rel up for amd64 rebuild

Revision 1.40  2003/11/24 12:17:24  averne
- updated release

Revision 1.39  2003/05/25 11:00:59  malekith
- massive attack, adding Source-md5

Revision 1.38  2003/05/25 06:26:40  misi3k
- massive attack s/pld.org.pl/pld-linux.org/

Revision 1.37  2003/01/15 01:04:20  radek
- updated Source0 URL

Revision 1.36  2002/12/20 14:09:15  qboosh
- don't try to setserial ttySL* in rc.serial - it won't work
- release 11

Revision 1.35  2002/08/16 13:31:26  kloczek
- release 10.

Revision 1.34  2002/08/16 11:33:06  misiek
- noreplace on config

Revision 1.33  2002/06/29 12:00:44  kloczek
- release 9: use new %doc and merge translations from Conectiva and TurboLinux.

Revision 1.32  2002/05/21 23:14:42  kloczek
perl -pi -e "s/^automake -a -c -f --foreing/\%\{__automake\}/; \
             s/^automake -a -c -f/\%\{__automake\}/; \
	     s/^autoconf/\%\{__autoconf\}/"

Revision 1.31  2002/04/03 06:11:54  kloczek
- relase 7: merge translatins from KSI.

Revision 1.30  2002/02/23 04:41:58  kloczek
- adapterized.

Revision 1.29  2002/02/22 23:29:43  kloczek
- removed all Group fields translations (oure rpm now can handle translating
  Group field using gettext).

Revision 1.28  2002/01/18 02:14:53  kloczek
perl -pi -e "s/pld-list\@pld.org.pl/feedback\@pld.org.pl/"

Revision 1.27  2001/10/11 14:14:03  qboosh
- BuildRequires: autoconf

Revision 1.26  2001/08/08 22:53:33  agaran
yes it should be groff

Revision 1.25  2001/08/08 22:45:09  agaran
added nroff to buildrequires(or maybe that should be groff?)

Revision 1.24  2001/06/22 05:06:22  kloczek
- Prereq replaced by Requires.

Revision 1.23  2001/06/22 05:05:34  kloczek
- release 4: Prereq: rc-scripts.

Revision 1.22  2000/10/25 03:54:22  kloczek
- release 3: use new rpm automation.

Revision 1.21  2000/06/09 07:23:59  kloczek
- added using %%{__make} macro.

Revision 1.20  2000/04/01 11:15:40  zagrodzki
- changed all BuildRoot definitons
- removed all applnkdir defs
- changed some prereqs/requires
- removed duplicate empty lines

Revision 1.19  2000/03/28 16:55:06  baggins
- translated kloczkish into english

Revision 1.18  2000/02/17 13:34:50  kloczek
- updated to 2.17.

Revision 1.17  2000/01/21 00:14:10  kloczek
- release 25,
- pass "-s" in CFLAGS for producing stripped binaries on linking,
- added ru translation from rawhide spec.

Revision 1.16  1999/10/04 09:13:59  kloczek
- release 8,
- replace started() by pair busy(), ok() in rc.serial script,
- added pl man page for setserial.

Revision 1.15  1999/08/01 01:46:52  kloczek
- fix: added passing
  binaries).

Revision 1.14  1999/07/27 14:03:53  kloczek
- release 7.

Revision 1.13  1999/07/27 13:13:35  misiek
added debian patch

Revision 1.12  1999/07/23 00:44:40  kloczek
- release 6.

Revision 1.11  1999/07/14 17:23:23  kloczek
- release changed to 5.1,
- removed URL,
- full Source Url,
- added text in %description about /etc/sysconfig/serial,
- /etc/rc.d/rc.serial moved from rc-scripts.

Revision 1.10  1999/07/14 15:38:18  baggins
- FHS 2.0
- gzip instaed of bzip2

Revision 1.9  1999/07/12 23:06:14  kloczek
- added using CVS keywords in %changelog (for automating them).

* Thu Feb 18 1999 Wojtek Ślusarczyk <wojtek@shadow.eu.org>
  [2.15-4d]
- compressed documentation,
- fixed Group.

* Thu Feb 18 1999 Arkadiusz Miśkiewicz <misiek@misiek.eu.org>
  [2.15-3d]
- configuration file in new location

* Thu Dec 24 1998 Arkadiusz Miśkiewicz <misiek@misiek.eu.org>
  [2.15-2d]
- removed /etc/rc.d/init.d/serial (this is now done by rc-scripts).

* Sat Nov 07 1998 Arkadiusz Miśkiewicz <misiek@misiek.eu.org>
  [2.15-1d]
- new upstream release (2.15),
- added /etc/rc.d/init.d/serial and /etc/serial.conf,
- added Group(pl),
- added %post and %preun.

* Mon Oct 26 1998 Wojtek Ślusarczyk <wojtek@shadow.eu.org>
  [2.14-1d]
- updated to 2.14,
- minor changes.

* Sun Oct 18 1998 Marcin Korzonek <mkorz@shadow.eu.org>
  [2.12-5d]
- translations modified for pl,
- defined files permission,
- simplifications in %build and %install section.

* Thu Jul 23 1998 Wojtek Ślusarczyk <wojtek@shadow.eu.org>
  [2.12-5]
- build against GNU libc-2.1.
